#ifndef GGAP_PREFS_DIALOG_H
#define GGAP_PREFS_DIALOG_H

#include <ggap/dialogs.h>
#include <QPointer>

namespace ggap {

class PrefsDialogBase : public moo::NiceDialog {

    void accept();
    virtual void apply() = 0;

protected:
    PrefsDialogBase(QWidget *parent);
    virtual void init() = 0;
};

class PrefsDialog : public PrefsDialogBase {
    Q_OBJECT
    struct Private;
    Private *priv;

    void init();
    void apply();

public:
    PrefsDialog(QWidget *parent = 0);
    ~PrefsDialog();

    static void showDialog(QWidget *parent);
    static void execDialog(QWidget *parent);

private Q_SLOTS:
    void advancedPrefs();
    void on_buttonGapDir_clicked();
    void on_buttonGapExe_clicked();
    void on_buttonGapRoots_clicked();
    void on_buttonWorksheetFont_clicked();
    void on_buttonHelpFont_clicked();
    void on_buttonUseDefaultGap_stateChanged(int state);
    void on_buttonBox_helpRequested();
};

}

#endif // GGAP_PREFS_DIALOG_H
